# Audio Wavesurfer

Audio Wavesurfer module provide a field formatter to display audio with waveform. It also provide an option to manage waveform on back side to avoid delay on front due to time calculation on long audio file.

## Installation

### Wavesurfer library
It is possible to download the library ```npm install --save wavesurfer.js``` and specify its location in `/admin/config/audio_wavesurfer/settings`.
For this module you need to download :
 - /wavesurfer.esm.js
 - /plugins/hover.esm.js

**Example:** If wavesurfer.esm.js is here library/nodes_modules_wavesurfer.js/dist the path that you need to set in configuration is library/nodes_modules_wavesurfer.js/dist.

If the file path is not specified, the CDN library will be downloaded.

### FFMpeg Installation
Required by Waveform Storage. For example on docker alpine :
```sh
RUN apk upgrade && apk add --no-cache ffmpeg
```

## Configuration

### Wavesurfer configuration
Color and bar are customizable on `/admin/config/audio_wavesurfer/settings`. It's also possible on this settings to activate Waveform Storage. Waveform storage allow to calculate waveform point on file upload to avoid JS to do the calculation on front. For long audio file it could be really usefull because thanks to this option wafeform in instantly display on front.

**IMPORTANT: to use Waveform Storage it is necessary to have FFMpeg library**

## Audio Wavesurfer Formatter
Go on audio media configuration `/admin/structure/media/manage/audio/display` and select Audio Wavesurfer Formatter as Format.

## How It Works
This module use Wavesurfer library https://wavesurfer.xyz/docs/.
On https://wavesurfer.xyz/examples/?all-options.js there are the options to see how waveform is rendered. Only essential options are available on this module, colors and bar style.

---

