(function (Drupal, drupalSettings, once) {
  Drupal.behaviors.audioBehavior = {
    attach: function (context, settings) {
      once('audioBehavior', '.audio-waveform-container', context).forEach(function (element) {
        let waveFormPeaks = null;
        if (drupalSettings.audio_wavesurfer && drupalSettings.audio_wavesurfer.waveform_peaks) {
          waveFormPeaks = drupalSettings.audio_wavesurfer.waveform_peaks;
        }

        let options = null;
        if (drupalSettings.audio_wavesurfer && drupalSettings.audio_wavesurfer.options) {
          options = drupalSettings.audio_wavesurfer.options;
        }

        new AudioWavesurfer(element, waveFormPeaks, options);
      });
    }
  };

}(Drupal, drupalSettings, once));
