(function (Drupal, once) {
  Drupal.behaviors.audioClipBehavior = {
    attach: function (context, settings) {
      once('audioClipBehavior', '.audio-waveform-container', context).forEach(function (element) {
        const audioWavesurferContainer = document.querySelector('.audio-waveform-container');
        if (audioWavesurferContainer) {
          // Add necessary elements for clip display
          const sliderContainer = document.createElement('div');
          const waveformContainer = audioWavesurferContainer.querySelector('.waveform');
          sliderContainer.className = 'sous-parent';
          waveformContainer.after(sliderContainer);

          const buttonRegionsContainer = document.createElement('div');
          const playButton = audioWavesurferContainer.querySelector('.play-button-container .play-button');
          buttonRegionsContainer.className = 'play-regions-button-container';
          playButton.after(buttonRegionsContainer);

          const audioWavesurfer = new AudioWavesurfer(audioWavesurferContainer);
          new AudioWaveSurferRegion(audioWavesurfer.wavesurfer, audioWavesurferContainer);
        }
      });
    }
  };

}(Drupal, once));
